﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MovingObjectOnForm
{
    public partial class FormView1 : Form
    {

        private int _x;
        private int _y;
        private int _vx;
        private int _vy;
        private int _pWidth;
        private int _pHeight;
        private int _frame;
        private int _row ;
        private int _column;
         int _gridSize = 9;
         int _gridLength;
        

        PictureBox[] pbName = new PictureBox[99];

        public FormView1()
        {
            InitializeComponent();
            //pictureBox.Location
            //int _x = 5; // pictureBox1.Location.X
           // int _y = 5; // pictureBox1.Location.Y
            // velocity
            int _vx = 0;
            int _vy = 0;
            int _pWidth = 16;
            int _pHeight = 16;
            int _frame = 0;
            int _row = 0;
            int _column = 0;

            _gridLength  = (_gridSize * _gridSize) + 1;
            //int _gridSize = 4;

            // create  new boxes
            for (int i = 1; i < _gridLength; i++)
            {
                pbName[i] = new PictureBox();
                pbName[i].Size = new Size(_pWidth, _pHeight);
                //pbName[i].Image = Image.FromFile(fileName[i]); // image box image from file
                pbName[i].Image = imageList1.Images[i];
                pbName[i].Name = "pictureBox" + i.ToString();
                _x = _column * _pWidth; //pBox.Location.X;
                _y = _row * _pHeight; //pBox.Location.Y;
                _column++;
                 if (_column == _gridSize) { _row++; _column = 0; }
                 pbName[i].Location = new Point(_x, _y);

                 pbName[i].Parent = this.panel1;
            }
             _column = 0;
            
        }

        private void PictureBoxesGrid(int gridSize, int pWidth, int pHeight)
        {
        // places picture boxes in a grid
            for (int box = 1; box < 5; box++)
            {
                        PictureBox pBox = (PictureBox)this.Controls.Find("pictureBox" + box, true)[0];
                        _x = _column * _pWidth; //pBox.Location.X;
                        _y = _row * _pHeight; //pBox.Location.Y;
                        _column++;
                        if (_column > _gridSize) { _row++; _column = 0; }

                        pBox.Location = new Point(_x, _y);
            }
        }

        private void FormView_Load(object sender, EventArgs e)
        {

        }
        

        #region Timer Move Tick Moves Images
        private void tmrMove_Tick(object sender, EventArgs e)
        {
            for (int i = 1; i < _gridLength; i++)
            {
                PictureBox pBox = (PictureBox)this.Controls.Find("pictureBox" + i, true)[0];
                _x = pBox.Location.X;
                _y = pBox.Location.Y;
                _x += _vx;
                _y += _vy;
                pBox.Location = new Point(_x, _y);
            }
           
            

            _frame++;
            if (_frame == imageList1.Images.Count) { _frame = 0; }
            //animate by using imageList
            for (int i = 1; i < _gridLength; i++)
            {
                PictureBox pBox = (PictureBox)this.Controls.Find("pictureBox" + i, true)[0];

                pBox.Image = imageList1.Images[_frame];
            }
            Invalidate(); // no updates without Invalidate()?
        }
        #endregion


        // paint object at x,y, with ugly blitting.
        private void FormView_Paint(object sender, PaintEventArgs e)
        {
            // e.Graphics.FillRectangle(Brushes.BlueViolet, _x, _y, 200, 200);
        }


        #region KeyDown
        private void FormView_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode.ToString() == "D") { _vx = 5; _vy = 0; }
            if (e.KeyCode.ToString() == "A") { _vx = -5; _vy = 0; }
            if (e.KeyCode.ToString() == "S") { _vy = 5; _vx = 0; }
            if (e.KeyCode.ToString() == "W") { _vy = -5; _vx = 0; }
        }
        #endregion

        


    }
}
